﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Private manager As BleManager2
	Private rp As RuntimePermissions
			
	Public BLEName As String
	Public BLEId As String
	Public BLEService As String
	Public BLECharacteristic As String
	
	Public BLE_STATE_OFF As Int = 0
	Public BLE_STATE_IDLE As Int = 1
	Public BLE_STATE_SCANNING As Int = 2
	Public BLE_STATE_CONNECTING As Int = 3
	Public BLE_STATE_READING As Int = 4
	Public BLE_STATE_STREAMING As Int = 5
	
	Public BLEState As Int = BLE_STATE_OFF
	
	Dim ReadTimer As Timer
	Dim LastReadTime As Long
	
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.

	ReadTimer.Initialize("ReadTimer", 100)
	ReadTimer.Enabled = True
	
	manager.Initialize("manager")
	Log("manager.Initialize")
		
End Sub

Sub Service_Start (StartingIntent As Intent)
	
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

Sub Manager_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
	
	Log(Id & " " & Name)
		
	'''If Id.EndsWith("9D:0A") Then	
	If Id.EndsWith("B9:AA") Then
		manager.StopScan
		Log("manager.StopScan")
		
		BLEName = Name
		BLEId = Id
		
		manager.Connect2(BLEId, False)
		Log("manager.Connect2 " & BLEId)
		BLEState = BLE_STATE_CONNECTING
	End If
	
End Sub

Sub Manager_Connected(Services As List)
	
	For Each S As String In Services
		Log(S)
		'''If S.StartsWith("cc4a6a80") Then
		If S.StartsWith("0000a002") Then
		
			BLEService = S
			
			BLEState = BLE_STATE_READING
			LastReadTime = 0    'will trigger ReadData on next timer tick
		End If
	Next
	
End Sub

Sub Manager_DataAvailable(ServiceID As String, Characteristics As Map)
	
	For Each C As String In Characteristics.Keys
		Log(C)
		'''If C.StartsWith("835ab4c0") Then
		If C.StartsWith("0000c301") Then
			BLECharacteristic = C
			
		    Dim TempB() As Byte = Characteristics.Get(BLECharacteristic)
			
			Dim DecimalBytes As String
			For I = 0 To TempB.Length -1
				DecimalBytes = DecimalBytes & " " & TempB(I)
			Next
			
			Dim MillisecondsSinceReadData As Long = DateTime.Now - LastReadTime
			LogColor("Data read time = " & MillisecondsSinceReadData, Colors.Blue)
			LogColor("Data (decimal bytes) = " & DecimalBytes, Colors.Blue)
			
			'If BLEState <> BLE_STATE_STREAMING Then
			'	manager.SetNotify(BLEService, BLECharacteristic, True)
			'	BLEState = BLE_STATE_STREAMING
			'End If
			
			LastReadTime = 0    'will trigger ReadData on next timer tick
		End If
	Next
	
End Sub

Public Sub StartScan
		
	Log("StartScan")
	
	If manager.State <> manager.STATE_POWERED_ON Then
		Log("Not powered on.")
	Else If rp.Check(rp.PERMISSION_ACCESS_COARSE_LOCATION) = False Then
		Log("No location permission.")
	Else
		manager.Scan2(Null, False)    'or True to see repeated advertisements
		Log("manager.Scan2")
		BLEState = BLE_STATE_SCANNING
		
		Sleep(20000)
		
		If BLEState = BLE_STATE_SCANNING Then
			manager.StopScan
			Log("manager.StopScan")
			BLEState = BLE_STATE_IDLE
		End If
	End If

End Sub

Sub ReadTimer_Tick

	If BLEState = BLE_STATE_READING Then
		If DateTime.Now - LastReadTime > 10000 Then
			manager.ReadData(BLEService)    'initiate read
			Log("manager.ReadData " & BLEService)
			
			LastReadTime = DateTime.Now    'times out in 10 seconds to continue reads even if no data received
		End If
	End If
	
End Sub